require 'sketchup.rb'

module BM_CameraCoords

def self.main_proc()
	view = Sketchup.active_model.active_view
	camera = view.camera
	eye = camera.eye
	target = camera.target
	up = camera.up
	
	# ------------------------------------------------------
	# Get user input.  Defaults to current camera position
	# ------------------------------------------------------
	prompts = ["Camera location", 
		"Target location", 
		"Up vector"]
		
	defaults = [sprintf("%.2f,%.2f,%.2f", eye.x, eye.y, eye.z), 
		sprintf("%.2f,%.2f,%.2f", target.x, target.y, target.z), 
		sprintf("%.2f,%.2f,%.2f", up.x, up.y, up.z)]
		
	lists = ["", "", ""]
	
	userinput = UI.inputbox prompts, defaults, lists, "Camera position"
	if !userinput || userinput.nil?
		return 
	end
	
	newEye = userinput[0].split(',')
	newTarget = userinput[1].split(',')
	newUp = userinput[2].split(',')
	
	eye = Geom::Point3d.new(newEye[0].to_f, newEye[1].to_f, newEye[2].to_f)
	target = Geom::Point3d.new(newTarget[0].to_f, newTarget[1].to_f, newTarget[1].to_f)
	up = Geom::Vector3d.new(newUp[0].to_f, newUp[1].to_f, newUp[2].to_f)
	
	# set new position
	camera.set(eye, target, up)

end


unless file_loaded?(__FILE__)
	UI.menu('Camera').add_item("Position Camera by Coords") { main_proc() }	
end
file_loaded(__FILE__)	


end #module